diff --git a/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java
index ea72f10af..289690c39 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java
@@ -3,8 +3,10 @@ package net.minecraft.client.gui.hud;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.GuiIngame;
-import net.minecraft.core.item.ItemBucketIceCream;
-import net.minecraft.core.item.ItemFood;
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.item.IceCreamBucketItem;
+import net.minecraft.core.item.FoodItem;
 import net.minecraft.core.player.gamemode.Gamemode;
 import org.lwjgl.opengl.GL11;
 
@@ -30,7 +32,6 @@ public class HealthBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         boolean heartsFlash = (mc.thePlayer.heartsFlashTime / 3) % 2 == 1;
@@ -41,7 +42,7 @@ public class HealthBarComponent
         int health = mc.thePlayer.getHealth();
         int prevHealth = mc.thePlayer.prevHealth;
         random.setSeed(gui.updateCounter * 0x4c627L);
-        int v = mc.thePlayer.getGamemode() == Gamemode.hardcore ? 27 : 0;
+        boolean isHardcore = mc.thePlayer.getGamemode() == Gamemode.hardcore;
 
         for (int i = 0; i < 10; i++) {
             int heartOffset = 0;
@@ -56,55 +57,55 @@ public class HealthBarComponent
                 yHeart += random.nextInt(2);
             }
 
-            gui.drawTexturedModalRect(xHeart, yHeart, 16 + heartOffset * 9, v, 9, 9);
+            gui.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture("minecraft:gui/hud/heart/container") : TextureRegistry.getTexture("minecraft:gui/hud/heart/container_blinking"));
             if (heartsFlash)
             {
                 if (i * 2 + 1 < prevHealth)
                 {
                     // Half flash heart icon
-                    gui.drawTexturedModalRect(xHeart, yHeart, 70, v, 9, 9);
+                    gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full_blinking"));
                 }
                 if (i * 2 + 1 == prevHealth)
                 {
                     // Full flash heart icon
-                    gui.drawTexturedModalRect(xHeart, yHeart, 79, v, 9, 9);
+                    gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half_blinking"));
                 }
             }
             if (i * 2 + 1 < health)
             {
                 // Full heart icon
-                gui.drawTexturedModalRect(xHeart, yHeart, 52, v, 9, 9);
+                gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full"));
             }
             if (i * 2 + 1 == health)
             {
                 // Half heart icon
-                gui.drawTexturedModalRect(xHeart, yHeart, 61, v, 9, 9);
+                gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half"));
             }
-            if (mc.thePlayer.inventory.getCurrentItem() != null && (mc.thePlayer.inventory.getCurrentItem().getItem() instanceof ItemFood || mc.thePlayer.inventory.getCurrentItem().getItem() instanceof ItemBucketIceCream) && mc.gameSettings.foodHealthRegenOverlay.value)
+            if (mc.thePlayer.inventory.getCurrentItem() != null && (mc.thePlayer.inventory.getCurrentItem().getItem() instanceof FoodItem || mc.thePlayer.inventory.getCurrentItem().getItem() instanceof IceCreamBucketItem) && mc.gameSettings.foodHealthRegenOverlay.value)
             {
                 int healing = 0;
-                if (mc.thePlayer.inventory.getCurrentItem().getItem() instanceof ItemFood)
+                if (mc.thePlayer.inventory.getCurrentItem().getItem() instanceof FoodItem)
                 {
-                    healing = ((ItemFood) mc.thePlayer.inventory.getCurrentItem().getItem()).getHealAmount();
+                    healing = ((FoodItem) mc.thePlayer.inventory.getCurrentItem().getItem()).getHealAmount();
                 }
                 else
                 {
-                    healing = ((ItemBucketIceCream) mc.thePlayer.inventory.getCurrentItem().getItem()).getHealAmount();
+                    healing = ((IceCreamBucketItem) mc.thePlayer.inventory.getCurrentItem().getItem()).getHealAmount();
                 }
 
                 if (i * 2 + 1 >= health)
                 {
                     if (i * 2 + 1 == health)
                     {
-                        gui.drawTexturedModalRect(xHeart, yHeart, 106, 0, 9, 9);
+                        gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_half_right"));
                     }
                     else if (i * 2 + 1 < health + healing)
                     {
-                        gui.drawTexturedModalRect(xHeart, yHeart, 88, 0, 9, 9);
+                        gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_full"));
                     }
                     else if (i * 2 + 1 == health + healing)
                     {
-                        gui.drawTexturedModalRect(xHeart, yHeart, 97, 0, 9, 9);
+                        gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_half"));
                     }
                 }
             }
@@ -118,22 +119,21 @@ public class HealthBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int health = 11;
         for (int i = 0; i < 10; i++) {
             int xHeart = x + i * 8;
-            gui.drawTexturedModalRect(xHeart, y, 16, 0, 9, 9);
+            gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
             if (i * 2 + 1 < health)
             {
                 // Full heart icon
-                gui.drawTexturedModalRect(xHeart, y, 52, 0, 9, 9);
+                gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/full"));
             }
             if (i * 2 + 1 == health)
             {
                 // Half heart icon
-                gui.drawTexturedModalRect(xHeart, y, 61, 0, 9, 9);
+                gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/half"));
             }
         }
     }
diff --git a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
index 96d56e2af..352a69c55 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
@@ -2,31 +2,32 @@ package net.minecraft.client.gui.hud;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiHeldItemTooltip;
 import net.minecraft.client.gui.GuiIngame;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.item.model.ItemModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.Block;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.InventoryPlayer;
+import net.minecraft.core.player.inventory.container.Inventory;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
 public class HotbarComponent
     extends MovableHudComponent {
     private static final ItemStack[] PREVIEW_ITEMS = new ItemStack[] {
-        new ItemStack(Block.stone),
-        new ItemStack(Block.cobbleStone),
-        new ItemStack(Block.brickClay),
-        new ItemStack(Block.dirt),
-        new ItemStack(Block.planksOak),
-        new ItemStack(Block.logOak),
-        new ItemStack(Block.leavesOak),
-        new ItemStack(Block.glass),
-        new ItemStack(Block.slabStonePolished)
+        new ItemStack(Blocks.STONE),
+        new ItemStack(Blocks.COBBLE_STONE),
+        new ItemStack(Blocks.BRICK_CLAY),
+        new ItemStack(Blocks.DIRT),
+        new ItemStack(Blocks.PLANKS_OAK),
+        new ItemStack(Blocks.LOG_OAK),
+        new ItemStack(Blocks.LEAVES_OAK),
+        new ItemStack(Blocks.GLASS),
+        new ItemStack(Blocks.SLAB_STONE_POLISHED)
     };
 
     public HotbarComponent(String key, Layout layout) {
@@ -54,19 +55,20 @@ public class HotbarComponent
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
         int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
 
-        InventoryPlayer inv = mc.thePlayer.inventory;
+        Inventory inv = mc.thePlayer.inventory;
 
         // Setup hotbar texture
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
 
         // Render hotbar
-        gui.drawTexturedModalRect(x + 5, y, 0, 0, 182, 22);
+        gui.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
+
 
         // Render hotbar switcher and dots
         int selectedHotbar = ((inv.hotbarOffset + 27) % 36) / 9;
-        gui.drawTexturedModalRect(x, y, 24, 22, 6, 22);
-        gui.drawTexturedModalRect(x, y + 1 + selectedHotbar * 5, 30, 23 + selectedHotbar * 5 ,6 ,5);
+        IconCoordinate coordinate = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector");
+        gui.drawIconTexture(x, y, x + 6, y + 22, 0, 0, 6, 22, coordinate);
+        gui.drawIconTexture(x, y + selectedHotbar * 5, x + 6, y + selectedHotbar * 5 + 5, 6, selectedHotbar * 5, 12, selectedHotbar * 5 + 5, coordinate);
 
         // Setup items
         GL11.glEnable(GL11.GL_DEPTH_TEST);
@@ -120,10 +122,9 @@ public class HotbarComponent
 
         // Setup hotbar texture
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
 
         // Render selector
-        gui.drawTexturedModalRect((x + 4) + (inv.currentItem % 9) * 20, y - 1, 0, 22, 24, 24);
+        gui.drawGuiIcon((x + 4) + (inv.currentItem % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selection"));
 
         gui.guiHeldItemTooltip.updateAndRender(mc, x + 187/2, y - 20);
     }
@@ -135,17 +136,18 @@ public class HotbarComponent
 
         // Setup hotbar texture
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
 
         // Render hotbar
-        gui.drawTexturedModalRect(x + 5, y, 0, 0, 182, 22);
+        gui.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
 
         // Render hotbar switcher and dots
-        gui.drawTexturedModalRect(x, y, 24, 22, 6, 22);
-        gui.drawTexturedModalRect(x, y + 16, 30, 23, 6,5);
+        IconCoordinate coordinate = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector");
+        gui.drawIconTexture(x, y,       x + 6, y + 22, 0, 0, 6, 22, coordinate);
+        gui.drawIconTexture(x, y + 15,  x + 6, y + 15 + 5, 6, 5, 12, 10, coordinate);
 
         // Render selector
-        gui.drawTexturedModalRect(x + 4, y - 1, 0, 22, 24, 24);
+        gui.drawGuiIcon((x + 4), y - 1, 24, 24, TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selection"));
+
 
         // Setup items
         GL11.glEnable(GL11.GL_DEPTH_TEST);
diff --git a/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java
index f1a5542d3..1028528ac 100644
--- a/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java
@@ -3,13 +3,19 @@ package net.minecraft.client.gui.hud;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Material;
 import org.lwjgl.opengl.GL11;
 
 public class OxygenBarComponent
     extends MovableHudComponent {
+    private final IconCoordinate air;
+    private final IconCoordinate air_pop;
     public OxygenBarComponent(String key, Layout layout) {
         super(key, 81, 10, layout);
+        air = TextureRegistry.getTexture("minecraft:gui/hud/air");
+        air_pop = TextureRegistry.getTexture("minecraft:gui/hud/air_pop");
     }
 
     @Override
@@ -24,7 +30,6 @@ public class OxygenBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int numBubbles = (int) Math.ceil(((double) (mc.thePlayer.airSupply - 2) * 10D) / 300D);
@@ -33,11 +38,11 @@ public class OxygenBarComponent
         {
             if (i < numBubbles)
             {
-                gui.drawTexturedModalRect(x + i * 8, y, 16, 18, 9, 9);
+                gui.drawGuiIcon(x + i * 8, y, 9, 9, air);
             }
             else
             {
-                gui.drawTexturedModalRect(x + i * 8, y, 25, 18, 9, 9);
+                gui.drawGuiIcon(x + i * 8, y, 9, 9, air_pop);
             }
         }
     }
@@ -49,7 +54,6 @@ public class OxygenBarComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int numBubbles = 5;
@@ -58,11 +62,11 @@ public class OxygenBarComponent
         {
             if (i < numBubbles)
             {
-                gui.drawTexturedModalRect(x + i * 8, y, 16, 18, 9, 9);
+                gui.drawGuiIcon(x + i * 8, y, 9, 9, air);
             }
             else
             {
-                gui.drawTexturedModalRect(x + i * 8, y, 25, 18, 9, 9);
+                gui.drawGuiIcon(x + i * 8, y, 9, 9, air_pop);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java b/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java
index 9856d4d73..02cc03dd5 100644
--- a/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java
@@ -3,7 +3,8 @@ package net.minecraft.client.gui.hud;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.GuiIngame;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import org.lwjgl.opengl.GL11;
 
@@ -22,16 +23,14 @@ public class RotationLockComponent
     public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
         int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
 
-        int u = mc.gameSettings.rotationOverlayMode.value % 2 == 1 ? 16 : 0;
-        int v = 160;
+        String prefix = mc.gameSettings.rotationOverlayMode.value % 2 == 1 ? "arrow" : "cube";
 
-        EntityPlayer player = mc.thePlayer;
+        Player player = mc.thePlayer;
 
         boolean facingUp = player.xRot < -45;
         boolean facingDown = player.xRot > 45;
@@ -78,9 +77,11 @@ public class RotationLockComponent
             }
         }
 
-        gui.drawTexturedModalRect(x, y, u, v + dir.index * 16, 16, 16);
+        String[] dirTextures = new String[]{"down", "up", "back", "front", "left", "right"};
+        gui.drawGuiIcon(x, y, 16, 16, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.getId()]));
         dir = Direction.getVerticalDirection(player);
-        gui.drawTexturedModalRect(x + 16, y + 4, u + (dir.index - 4) * 8, v - 8, 8, 8);
+        dirTextures = new String[]{"downer", "upper", "back", "front", "left", "right"};
+        gui.drawGuiIcon(x + 16, y + 4, 8, 8, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.getId()]));
     }
 
     @Override
@@ -90,13 +91,11 @@ public class RotationLockComponent
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/icons.png"));
         GL11.glDisable(GL11.GL_BLEND);
 
-        int u = mc.gameSettings.rotationOverlayMode.value % 2 == 1 ? 16 : 0;
-        int v = 160;
+        String prefix = mc.gameSettings.rotationOverlayMode.value % 2 == 1 ? "arrow" : "cube";
 
-        gui.drawTexturedModalRect(x, y, u, v, 16, 16);
-        gui.drawTexturedModalRect(x + 16, y + 4, u, v - 8, 8, 8);
+        gui.drawGuiIcon(x, y, 16, 16, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_front"));
+        gui.drawGuiIcon(x + 16, y + 4, 8, 8, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_downer"));
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
index caf228148..15ef85781 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.gui.modelviewer;
 
-import com.b100.utils.FileUtils;
 import com.b100.utils.ImageUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
@@ -12,25 +11,22 @@ import net.minecraft.client.gui.modelviewer.categories.ParticleCategory;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextureButton;
-import net.minecraft.client.gui.modelviewer.elements.IActionListener;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
 import net.minecraft.client.gui.options.GuiOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
-import net.minecraft.client.render.Texture;
-import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.shader.PhotoModeRenderer;
 import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.client.render.shader.ShadersRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Buffer;
 import net.minecraft.core.util.helper.Utils;
-import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -87,7 +83,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
         mc.thePlayer.absMoveTo(0.5, 64.5, 0.5, 180, 0);
         mc.thePlayer.noPhysics = true;
         mc.renderEngine.refreshTexturesAndDisplayErrors();
-        mc.renderEngine.updateDynamicTextures();
+        mc.renderEngine.updateDynamicTextures(false);
 
         if(Shaders.enableShaders) {
             photoModeRenderer = new PhotoModeRenderer(mc, this);
@@ -141,7 +137,8 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
 
         buttonReloadTextures = new GuiListenerButton(12, 21, height - 20, 98, 20, i18n.translateKey("gui.model_viewer.button.reload_textures"));
         buttonReloadTextures.setActionListener(() -> mc.renderEngine.refreshTexturesAndDisplayErrors());
-        buttonOpenScreenshotFolder = new GuiListenerTextureButton(30, "/assets/minecraft/textures/gui/gui.png", buttonReloadTextures.getWidth() + buttonReloadTextures.getX() + 1, buttonReloadTextures.getY(), 100, 106 - 20, 20, 20);
+        buttonOpenScreenshotFolder = (GuiListenerButton) new GuiListenerButton(30, buttonReloadTextures.getWidth() + buttonReloadTextures.getX() + 1, buttonReloadTextures.getY(), 20, 20, "")
+            .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder");
         buttonOpenScreenshotFolder.setActionListener(() -> Utils.openDirectory(new File(mc.getMinecraftDir(), "")));
 
         buttonCenterScreen = new GuiListenerButton(10, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
@@ -381,7 +378,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
 
         scroll(Mouse.getDWheel());
 
-        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
+        BlockEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new BlockEntity(), -0.5D, -0.75D, -0.5D, partialTick);
 
         drawStringCentered(fontRenderer, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
     }
@@ -433,7 +430,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
         Minecraft.doPartialTick = tickProgress;
     }
     private void entryTick(){
-        mc.renderEngine.updateDynamicTextures();
+        mc.renderEngine.updateDynamicTextures(false);
         mc.effectRenderer.updateEffects();
         currentCategory.onTick();
         // TODO this fixes world time based animation, but also ticks things like wind and im not certain on the best way to set wind direction arbitrarily right now
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
index 022063230..171038428 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
@@ -9,7 +9,8 @@ import net.minecraft.client.gui.modelviewer.categories.entries.block.MobSpawnerE
 import net.minecraft.client.gui.modelviewer.categories.entries.block.SignEntry;
 import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
@@ -32,10 +33,10 @@ public class BlockCategory extends ModelViewerCategory {
             if (block == null) continue;
             entryHashMap.put(block, new BasicBlockEntry(block));
         }
-        entryHashMap.put(Block.signWallPlanksOak, new SignEntry(Block.signWallPlanksOak));
-        entryHashMap.put(Block.signPostPlanksOak, new SignEntry(Block.signPostPlanksOak));
-        entryHashMap.put(Block.mobspawner, new MobSpawnerEntry());
-        entryHashMap.put(Block.jarGlass, new JarEntry());
+        entryHashMap.put(Blocks.SIGN_WALL_PLANKS_OAK, new SignEntry(Blocks.SIGN_WALL_PLANKS_OAK));
+        entryHashMap.put(Blocks.SIGN_POST_PLANKS_OAK, new SignEntry(Blocks.SIGN_POST_PLANKS_OAK));
+        entryHashMap.put(Blocks.MOBSPAWNER, new MobSpawnerEntry());
+        entryHashMap.put(Blocks.JAR_GLASS, new JarEntry());
     }
 
     @Override
@@ -49,7 +50,7 @@ public class BlockCategory extends ModelViewerCategory {
         String name = "None";
         if (displayBlock != null){
             name = I18n.getInstance().translateNameKey(displayBlock.getKey());
-            ItemStack[] nameStack = displayBlock.getBreakResult(mc.theWorld, EnumDropCause.PICK_BLOCK, DisplayChunk.displayBlockPosX, DisplayChunk.displayBlockPosY, DisplayChunk.displayBlockPosZ, DisplayChunk.displayBlockMeta, DisplayChunk.displayTileEntity);
+            ItemStack[] nameStack = displayBlock.getBreakResult(mc.theWorld, EnumDropCause.PICK_BLOCK, DisplayChunk.displayBlockPosX, DisplayChunk.displayBlockPosY, DisplayChunk.displayBlockPosZ, DisplayChunk.displayBlockMeta, DisplayChunk.displayBlockEntity);
             if (nameStack != null && nameStack.length > 0){
                 name = nameStack[0].getDisplayName();
             }
@@ -166,7 +167,7 @@ public class BlockCategory extends ModelViewerCategory {
             entry.onTick(mc.theWorld, DisplayChunk.displayBlockMeta);
         }
         // Delete any items blocks create when added/removed
-        mc.theWorld.loadedEntityList.removeIf(entity -> entity instanceof EntityItem);
+        mc.theWorld.loadedEntityList.removeIf(entity -> entity instanceof ItemEntity);
     }
     public void setDisplayBlock(int id, int meta){
         Block displayBlock = Block.blocksList[DisplayChunk.displayBlockId];
@@ -188,7 +189,7 @@ public class BlockCategory extends ModelViewerCategory {
         displayBlock = Block.blocksList[id];
         if (displayBlock != null && _id != id){
             entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
-            displayBlock.onBlockAdded(mc.theWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z);
+            displayBlock.onBlockPlacedByWorld(mc.theWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z);
             if (entry != null) entry.onOpen(mc.theWorld, DisplayChunk.displayBlockMeta);
         }
         if (_id != id){
